\begin{tikzpicture}[framed]
  \clip (-4,-6) rectangle (10,4);

  \begin{scope}[on background layer]
    \fill[teal!10] (-2,-2) rectangle (2,0);
    \fill[purple!10] (0,0) rectangle (4,4);
    \fill[brown!10] (4,0) rectangle (8,2);
  \end{scope}

  \draw[black, dashed] (2,-1) circle (2.5);

  \draw[black,thick] (-4,-6) rectangle (10,4);
  \draw[step=2cm,black,very thick,name path=main_grid] (-4,-6) grid (10,4);
  \draw[step=2cm,black,very thin, dashed, shift={(0.5,0.5)}, name path=a_grid]
    (-4.5,-6.5) grid (9.5,3.5);
  \draw[step=2cm,black,very thin, dashed, shift={(-0.5,-0.5)}, name path=b_grid]
    (-3.5,-5.5) grid (10.5,4.5);

  \foreach \x in {-4,-2,0,2,4,6,8,10}
    \foreach \y in {-6,-4,-2,0,2,4}
      \draw[black, very thin, dashed] (\x,\y) circle (14pt);

  \foreach \x [count=\xi from 0] in {-3,-1,1,3,5,7,9,11}
    \foreach \y [count=\yi from 0] in {-5,-3,-1,1,3,5}
      \node at (\x,\y) {$c_{\xi\yi}$};

  % Path A1
  \draw[ultra thick, smooth, color=teal, postaction={decorate, name path=A1}]
    (-2,-3) .. controls (-1,1) and (3,-1.4) .. (7,-1.8);
  \fill [color=teal, name intersections={of=A1 and a_grid, total=\t}]
    \foreach \s in {1,...,\t} {(intersection-\s) circle (2.5pt)};
  \fill [color=teal, name intersections={of=A1 and b_grid, total=\t}]
    \foreach \s in {1,...,\t} {(intersection-\s) circle (2.5pt)};
  \node (A1) [minimum size=0.8cm, circle, ultra thick, draw, color=teal,
    fill=teal!20, label={[teal]above:$A_1$}] at (0.1,-0.8) {};
  \draw[ultra thick, color=teal, <-] (A1) ++(-0.15,-0.03) -- ++(0.3,0.06);

  % Path A2
  \draw[ultra thick, smooth, color=purple, postaction={decorate, name path=A2}]
    (-3,0) .. controls (0,3) and (4,3) .. (8,0);
  \fill [color=purple, name intersections={of=A2 and a_grid, total=\t}]
    \foreach \s in {1,...,\t} {(intersection-\s) circle (2.5pt)};
  \fill [color=purple, name intersections={of=A2 and b_grid, total=\t}]
    \foreach \s in {1,...,\t} {(intersection-\s) circle (2.5pt)};
  \node (A2) [minimum size=0.8cm, circle, ultra thick, draw, color=purple,
    fill=purple!20, label={[purple]above:$A_2$}] at (2.1, 2.25) {};
  \draw[ultra thick, color=purple, ->] (A2) ++(-0.15,0) -- ++(0.3,0);

  % Path A3
  \draw[ultra thick, smooth, color=brown, postaction={decorate, name path=A3}]
    (-1,-4) .. controls (-0.5,-1.5) and (7.5,1.5) .. (9,2);
  \fill [color=brown, name intersections={of=A3 and a_grid, total=\t}]
    \foreach \s in {1,...,\t} {(intersection-\s) circle (2.5pt)};
  \fill [color=brown, name intersections={of=A3 and b_grid, total=\t}]
    \foreach \s in {1,...,\t} {(intersection-\s) circle (2.5pt)};
  \node (A3) [minimum size=0.8cm, circle, ultra thick, draw, color=brown,
    fill=brown!20, label={[brown]below:$A_3$}] at (5.7, 0.72) {};
  \draw[ultra thick, color=brown, <-] (A3) ++(-0.15,-0.08) -- ++(0.3,0.14);
\end{tikzpicture}

